package com.fjhx.victoriatourist.service.jd.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundSelectDto;
import com.fjhx.victoriatourist.entity.jd.po.JdRefund;
import com.fjhx.victoriatourist.mapper.jd.JdRefundMapper;
import com.fjhx.victoriatourist.service.jd.JdRefundService;
import org.springframework.stereotype.Service;

import java.util.Date;


/**
 * <p>
 * 京东售后退货 服务实现类
 * </p>
 *
 * @author
 * @since 2024-09-25
 */
@Service
public class JdRefundServiceImpl extends ServiceImpl<JdRefundMapper, JdRefund> implements JdRefundService {

    @Override
    public Page<JdRefund> getPage(JdRefundSelectDto dto) {

        Date beginTime = dto.getBeginTime();
        Date endTime = dto.getEndTime();
        String keyword = dto.getKeyword();

        return page(dto.getPage(), q -> q
                .between(ObjectUtil.isAllNotEmpty(beginTime, endTime), JdRefund::getApplyDateTime, beginTime, endTime)
                .and(ObjectUtil.isNotEmpty(keyword),
                        k -> k.like(JdRefund::getSalesPin, keyword).or()
                                .like(JdRefund::getOutNo, keyword).or()
                                .like(JdRefund::getRefundId, keyword).or()
                                .like(JdRefund::getProviderName, keyword).or()
                                .like(JdRefund::getContacts, keyword)
                )
        );

    }

}
